function configure_table(table_id){	
	table = $("#"+table_id);
	table.data("tablesorter").widgets.push('print');
	table.data("tablesorter").widgets.push('columnSelector');
	table.data("tablesorter").widgetOptions['columnSelector_container']=$("#"+table_id+'_columnSelector');
	
	table.tablesorterPager({
        container: $( "#pager_"+table_id ),
        output: '{startRow} to {endRow} ({filteredRows})',
        size: 100,
    });
	
	$( '#'+table_id+'_print').on('click', function(){
          table.trigger('printTable');
	});
}

function create_scan_table(table_id){
	Utils.createTable("#"+table_id);
	configure_table(table_id);
}

function generateDonuts(dataVide,data,bind,legend,time,color='esia_state',unit=undefined,pwidth='auto',pheight=undefined,from='other') {
	if( typeof color !== 'object'){
		if(typeof color === 'string' && color == 'esia_state'){
			color = ['#83bc00', '#ffcb1f', '#da002e', '#575759', '#3263c5'];
		}
	}
	else if(color === null){
		color = undefined;
	}
	
	var position = 'bottom';
	if( typeof legend === 'string' ){
		position = legend;
		legend = true;
	}
	
	var arr = {label: {show: true}};
	if(pwidth !='auto')
	{
		arr = {	width:pwidth,label: {show: false}};
	}
	
	var chart = bb.generate({
	    bindto: '#'+bind,
	    data: {
    		columns: dataVide,
			type:'donut',
			empty: { label: { text: "No Data Available." }, },
		},
		color: {
			  pattern: color
			},
	    transition: {
		  duration: 500
		},
		legend: {
		  show: legend,
		  position : position
		},
		donut:  {
		    label: {
		        format: function (value) { return value; }
		      }
		    },
		size: {
		  height: pheight
		}
	});
	setTimeout(function () {
	    chart.load({
	    	columns: data,
	    });
	}, 100);
	return chart;
}

function generateTabbedDonuts(itemid,url,param,tabs) {
	var htm_tab = '<ul class="timeControl" data-id="'+itemid+'">';
	var first = true;
	$.each(tabs, function(key,value) {
		if( first ){
			htm_tab += '<li class="active" data-select="'+key+'">'+value+'</li>';
		}
		else{
			htm_tab += '<li data-select="'+key+'">'+value+'</li>';
		}
		first = false;
	});
	htm_tab += '</ul>';
	if(!$('#graph'+itemid).hasClass('addedGraphAlready')){
	   	$('#graph'+itemid).addClass('addedGraphAlready');
	$.get( url + '?' + "start=-1d&action=export&type=jsonC3&" + param ) 
	  .done(function( data ) {
	   	if(data[0] == "nothing") {
	   		$('#graph'+itemid).hide();
	   	}else{
	   		var i=1000;
	   			if(i>1000){
	   				if(!$('#showGraph'+itemid+i).length){
	   					$('#showGraph'+itemid+"1000").parent().find('canvas').before("<div id='showGraph"+itemid+i+"'></div>");
	   				}
	   				idAdd = i;
	   				chartSelector = itemid+i;
	   			}else{
	   				$('#showGraph'+itemid).attr('id',"showGraph"+itemid+i);
	   				idAdd = i;
	   				chartSelector = itemid+i;

	   				if(!$('#graph'+itemid+" .timeControl").length) {
				   		$('#showGraph'+itemid+idAdd).before(htm_tab);
				   		$('#showGraph'+itemid+idAdd).after('<canvas id="canvas"></canvas>');
	   				}
	   			}

	   			var arr=Array();
	   			var arr2=Array();
	   			$.each(data['data'], function(i,item) {
	   				arr2.push([i,0]);
	   				arr.push([i,item]);
		   		});
	   			
	   			var legend = true;
	   			if(data['parameter'][0]['legend'] === false ) legend = false;
	   			window["chart"+chartSelector] = generateDonuts(arr2,arr,'showGraph'+itemid+idAdd,legend,100,data['parameter'][0]['color']);
				
				// change le href lors de l'export csv en fonction du tab choisi (jour, semaine, mois, année) 
				$("#graph"+itemid+' .saveCSV').on('click', function(e){
					parent = this;
					$("#graph"+itemid+" ul li").each(function(){
						if($(this).hasClass('active')) {
							var datatype=$(this).data("select");
							$(parent).attr('href',url + '?' + "start=-"+ datatype +"&action=export&type=csv&" + param );
						}
					});
				});

				$("#graph"+itemid+" ul li").on('click', function(){
					
					parentSelector = $(this).parent().parent().parent();
					parentSelector.find('.theLoader').show();

					if(!$(this).hasClass('active')) {

						$(this).parent().find("li").removeClass('active');
						$(this).addClass('active');

						option = $(this).data("select");
						$.get( url + '?' + "start=-"+ option +"&action=export&type=jsonC3&" + param )
						  .done(function( data ) {
					//	   	if(data[0] != "nothing") {

						   		var i=1000;
						   		chartSelector = itemid+i;
						   		
						   		window["chart"+chartSelector].unzoom();
						   		window["chart"+chartSelector].unload();
						   		window["chart"+chartSelector].load({
						   			 json: data['data'],
						   		});
						   		window["chart"+chartSelector].flush();
						   	//}

							parentSelector.find('.theLoader').hide();
						  });
					}
				});
				i++;
	   	}
	  });
	}
}
